import xlrd
import numpy
import matplotlib.pyplot as plt

wb = xlrd.open_workbook('WW2_fighting_aircraft_performance.xls')
sh = wb.sheet_by_index(0)

Aoffset = 2
ii = 0
Ncat = 36

while sh.cell(ii+Aoffset,0).value != -1:
    ii = ii + 1

print ii,'entries found'

manufacturer = range(0,ii)
year_of_introduction = range(0,ii)
engine_power = range(0,ii)
max_speed = range(0,ii)
service_ceiling = range(0,ii)
wing_area = range(0,ii)
gross_weight = range(0,ii)
crew = range(0,ii)
number_of_engines = range(0,ii)
country_of_origin = range(0,ii)
rate_of_climb = range(0,ii)
engine_type = range(0,ii)

for jj in range(0,ii):
    manufacturer[jj] = sh.cell(jj+Aoffset,0).value
    year_of_introduction[jj] = sh.cell(jj+Aoffset,7).value
    max_speed[jj] = sh.cell(jj+Aoffset,25).value
    engine_power[jj] = sh.cell(jj+Aoffset,23).value
    service_ceiling[jj] = sh.cell(jj+Aoffset,29).value
    wing_area[jj] = sh.cell(jj+Aoffset,17).value
    gross_weight[jj] = sh.cell(jj+Aoffset,19).value
    crew[jj] = int(sh.cell(jj+Aoffset,13).value)
    number_of_engines[jj] = int(sh.cell(jj+Aoffset,21).value)
    country_of_origin[jj] = sh.cell(jj+Aoffset,4).value
    rate_of_climb[jj] = sh.cell(jj+Aoffset,30).value
    engine_type[jj] = sh.cell(jj+Aoffset,22).value

ind = []
for jj in range(0,ii):
    if (year_of_introduction[jj]!=-1 and engine_power[jj]!=-1 and country_of_origin[jj]=='NL'):
        ind.extend([jj])

print len(ind),'entries selected'

plt.plot(list(year_of_introduction[i] for i in ind),list(engine_power[i] for i in ind),'cv',markersize=7)

ind = []
for jj in range(0,ii):
    if (year_of_introduction[jj]!=-1 and engine_power[jj]!=-1 and country_of_origin[jj]=='F'):
        ind.extend([jj])

print len(ind),'entries selected'

plt.hold(True)
plt.plot(list(year_of_introduction[i] for i in ind),list(engine_power[i] for i in ind),'bs',markersize=7)

ind = []
for jj in range(0,ii):
    if (year_of_introduction[jj]!=-1 and engine_power[jj]!=-1 and country_of_origin[jj]=='P'):
        ind.extend([jj])

print len(ind),'entries selected'

plt.plot(list(year_of_introduction[i] for i in ind),list(engine_power[i] for i in ind),'rs',markersize=7)

ind = []
for jj in range(0,ii):
    if (year_of_introduction[jj]!=-1 and engine_power[jj]!=-1 and country_of_origin[jj]=='YU'):
        ind.extend([jj])

print len(ind),'entries selected'

plt.plot(list(year_of_introduction[i] for i in ind),list(engine_power[i] for i in ind),'wo',markersize=7)

plt.axis([1929,1946,0,2000])
plt.ylabel('Engine power [kW]')
plt.xlabel('Year of introduction')
plt.title('Fighter aircraft produced by countries occupied during WW2')

plt.plot(1930,1915,'cv',markersize=7)
plt.text(1930.3,1900,r'Netherlands', fontsize=10)
plt.plot(1930,1815,'bs',markersize=7)
plt.text(1930.3,1800,r'France',fontsize=10)
plt.plot(1930,1715,'rs',markersize=7)
plt.text(1930.3,1700,r'Poland', fontsize=10)
plt.plot(1930,1615,'wo',markersize=7)
plt.text(1930.3,1600,r'Yugoslavia',fontsize=10)


plt.grid(True)
plt.hold(True)
plt.show()

