import xlrd
import numpy
import matplotlib.pyplot as plt

wb = xlrd.open_workbook('WW2_fighting_aircraft_performance.xls')
sh = wb.sheet_by_index(0)

Aoffset = 2
ii = 0
Ncat = 36

while sh.cell(ii+Aoffset,0).value != -1:
    ii = ii + 1

print ii,'entries found'

manufacturer = range(0,ii)
year_of_introduction = range(0,ii)
engine_power = range(0,ii)
max_speed = range(0,ii)
service_ceiling = range(0,ii)
wing_area = range(0,ii)
gross_weight = range(0,ii)
crew = range(0,ii)
number_of_engines = range(0,ii)
country_of_origin = range(0,ii)
rate_of_climb = range(0,ii)
engine_type = range(0,ii)

for jj in range(0,ii):
    manufacturer[jj] = sh.cell(jj+Aoffset,0).value
    year_of_introduction[jj] = sh.cell(jj+Aoffset,7).value
    max_speed[jj] = sh.cell(jj+Aoffset,25).value
    engine_power[jj] = sh.cell(jj+Aoffset,23).value
    service_ceiling[jj] = sh.cell(jj+Aoffset,29).value
    wing_area[jj] = sh.cell(jj+Aoffset,17).value
    gross_weight[jj] = sh.cell(jj+Aoffset,19).value
    crew[jj] = int(sh.cell(jj+Aoffset,13).value)
    number_of_engines[jj] = int(sh.cell(jj+Aoffset,21).value)
    country_of_origin[jj] = sh.cell(jj+Aoffset,4).value
    rate_of_climb[jj] = sh.cell(jj+Aoffset,30).value
    engine_type[jj] = sh.cell(jj+Aoffset,22).value

ind = []
for jj in range(0,ii):
    if (crew[jj] == 1 and year_of_introduction[jj]!=-1 and engine_power[jj]!=-1 and rate_of_climb[jj]!=-1 and engine_type[jj]=='Radial 14'):
        ind.extend([jj])

print len(ind),'entries selected'

plt.plot(list(engine_power[i] for i in ind),list(max_speed[i] for i in ind),'co')

ind = []
for jj in range(0,ii):
    if (crew[jj] == 1 and year_of_introduction[jj]!=-1 and engine_power[jj]!=-1 and rate_of_climb[jj]!=-1 and engine_type[jj]=='V12'):
        ind.extend([jj])

print len(ind),'entries selected'

plt.hold(True)
plt.plot(list(engine_power[i] for i in ind),list(max_speed[i] for i in ind),'bv')

plt.plot(300,760,'bv',markersize=7)
plt.text(330,752,r'V-12', fontsize=10)
plt.plot(300,730,'co',markersize=7)
plt.text(330,722,r'Radial-14',fontsize=10)

plt.axis([200,1500,200,800])
plt.ylabel('Maximum speed [km/h]')
plt.xlabel('Engine power [kW]')
plt.title('Single seat fighter aircraft with V-12 and Radial-14 engines')

plt.grid(True)
plt.hold(True)
plt.show()

