import xlrd
import numpy
import matplotlib.pyplot as plt

wb = xlrd.open_workbook('WW2_fighting_aircraft_performance.xls')
sh = wb.sheet_by_index(0)

Aoffset = 2
ii = 0
Ncat = 36

while sh.cell(ii+Aoffset,0).value != -1:
    ii = ii + 1

print ii,'entries found'

manufacturer = range(0,ii)
year_of_introduction = range(0,ii)
engine_power = range(0,ii)
max_speed = range(0,ii)
service_ceiling = range(0,ii)
wing_area = range(0,ii)
gross_weight = range(0,ii)
crew = range(0,ii)
number_of_engines = range(0,ii)
country_of_origin = range(0,ii)

for jj in range(0,ii):
    manufacturer[jj] = sh.cell(jj+Aoffset,0).value
    year_of_introduction[jj] = sh.cell(jj+Aoffset,7).value
    max_speed[jj] = sh.cell(jj+Aoffset,25).value
    engine_power[jj] = sh.cell(jj+Aoffset,23).value
    service_ceiling[jj] = sh.cell(jj+Aoffset,29).value
    wing_area[jj] = sh.cell(jj+Aoffset,17).value
    gross_weight[jj] = sh.cell(jj+Aoffset,19).value
    crew[jj] = int(sh.cell(jj+Aoffset,13).value)
    number_of_engines[jj] = int(sh.cell(jj+Aoffset,21).value)
    country_of_origin[jj] = sh.cell(jj+Aoffset,4).value

ind = []
for jj in range(0,ii):
    if (crew[jj] == 1 and year_of_introduction[jj]!=-1 and max_speed[jj]!=-1):
        ind.extend([jj])

print len(ind),'entries selected'

plt.plot(list(year_of_introduction[i] for i in ind),list(max_speed[i] for i in ind),'co')

plt.axis([1924, 1946, 0, 1000])
plt.ylabel('Maximum speed [km/h]')
plt.xlabel('Year of introduction')
plt.title('Single seat fighter aircraft of all types used in WW2')
plt.text(1925, 130, r'Gloster Gamecock Mk 1',fontsize=10)
plt.annotate(' ', xy=(1926, 250), xytext=(1926.5, 150), arrowprops=dict(facecolor='black', width = 1, headwidth = 5, shrink=0.2),)
plt.text(1931.5,700,r'Supermarine Spitfire Mk VB',fontsize=10)
plt.annotate(' ', xy=(1938, 595), xytext=(1937.0, 690), arrowprops=dict(facecolor='black', width = 1, headwidth = 5, shrink=0.1),)
plt.text(1933.5,760,r'Focke-Wulf Fw 190 A-8',fontsize=10)
plt.annotate(' ', xy=(1941, 656), xytext=(1939, 750), arrowprops=dict(facecolor='black', width = 1, headwidth = 5, shrink=0.1),)
plt.text(1935.5,820,r'North American P-51D Mustang',fontsize=10)
plt.annotate(' ', xy=(1942, 703), xytext=(1940.5, 810), arrowprops=dict(facecolor='black', width = 1, headwidth = 5, shrink=0.15),)
plt.text(1937,930,r'Gloster Meteor F.8',fontsize=10)
plt.annotate(' ', xy=(1944, 965), xytext=(1941.5, 945), arrowprops=dict(facecolor='black', width = 1, headwidth = 5, shrink=0.15),)
plt.text(1940.5,360,r'Mitsubishi A6M2 Zero',fontsize=10)
plt.text(1940.5,330,r'Type 0 Model 11',fontsize=10)
plt.annotate(' ', xy=(1940, 534), xytext=(1942, 370), arrowprops=dict(facecolor='black', width = 1, headwidth = 5, shrink=0.15),)

plt.grid(True)
plt.hold(True)
plt.show()

